// Prozess-Priorisierung
//
// Hans-Georg Esser, 2021-11-20, Systemsoftware
//
// pa8-fork.c

#include <stdio.h>       // printf, fflush
#include <sys/types.h>   // fork
#include <unistd.h>      // fork, nice
#include <sys/types.h>   // wait
#include <sys/wait.h>    // wait
#include <stdlib.h>      // exit, strtol

#define KINDPROZESSE   16
#define WIEDERHOLUNGEN 50
#define WARTEZEIT      10000000

int nicevalue = 0;       // globale Variable

// Funktion worker() verbraucht einfach Rechenzeit
void worker (char c) {
	long akku = 0;
	if (c == 'B') nice (nicevalue);
	for (int i = 0; i < WIEDERHOLUNGEN; i++) {
		printf ("%c", c); fflush (stdout);
		for (int i = 0; i < WARTEZEIT; i++) akku++;
	}
}

int main (int argc, char* argv[]) {
	// Parameter vorhanden?
	if (argc > 1) {
		nicevalue = strtol (argv[1], NULL, 10);
		printf ("B-Prozesse laufen mit Nice-Wert %d\n", nicevalue);
	}

	// Kindprozesse starten, Haelfte "A", Haelfte "B"
	char c = 'A';
	for (int i = 0; i < KINDPROZESSE; i++) {
		if (i == KINDPROZESSE/2) c = 'B';
		int pid = fork ();
		if (pid == 0) {
			worker (c); exit (0);
		}
	}

	// Warten auf Kindprozesse
	for (int i = 0; i < KINDPROZESSE; i++) wait (NULL);
	printf ("\n");
}

